import csv
from datetime import datetime
import sys
import pandas as pd

FILE = 'TMGDSP202105.CSV'

#usrmonth = input("Month to be processed: ")

countofnotsms = int(1)


dictionary = {}

def add_dict(id, key, value):
    dict = dictionary.get(id)
    if key in dict:
        print("increasing notsms dict key for: ",value,"key IS: ",key)
        dict[key] += value

        print("end state: ",dict[key])
        dict[key] = round(dict[key],5)
        print("key: ",key)


    else:
        print("Never should happen", id)

def add_dictsms(id, pricesms):
    dict = dictionary.get(id)

    print("increasing sms dict key for dict: ",dict," for :",pricesms)
    dict["smscount"] += pricesms






#MAIN
with open(FILE, newline='', encoding='utf-8') as csvfile:
    reader = csv.DictReader(csvfile, delimiter=';')
    for row in reader:

        #print(row)
        if row['MSISDN'] == '': 
            continue #skip empty MSISDN

        #if row['BILLED_PERIOD_START'] == '':
            #continue

        #my_string = row['BILLED_PERIOD_START']
        #my_string = '2021-09-06'
        #print(my_string)
        #try:
            #my_date = datetime.strptime(my_string, "%Y-%m-%d")
        #except:
            #print("An exception occurred, current my_string is: ", my_string)
            #sys.exit(1)

        #print(row['BILLED_PERIOD_START'])
        #print(my_date.month)
        
        
        
         #if my_date.month != '5':
             #continue #skip bad dates



        MSISDN = int(row['MSISDN'])
        ICCID = int(row['ICCID'])
        price1 = float(row['CHARGE_NET'].replace(',','.'))
        
        price = round(price1, 5)
        print("before conditions price: ",price)

        typ = None
        if row['CHARGE_TYPE'] == "Pravidelné měsíční poplatky":
            typ = "data"
        elif row['CHARGE_TYPE'] == "Poplatky za roamingový datový provoz":
            typ = "data"
        elif row['CHARGE_TYPE'] == "Poplatky za národní datový provoz":
            typ = "data"
        elif row['CHARGE_TYPE'] == "Poplatky za roamingový SMS provoz":
            typ = "sms"
        elif row['CHARGE_TYPE'] == "Poplatky za národní SMS provoz":
            typ = "sms"
        else:
            typ = 'other'


        if row['INCREMENT'] == "SMS":

            pricesms = int(row['RATED_AMOUNT'])
        else:
            pricesms = 0

        #only if not exist create new record in dictionary for ID
        if not MSISDN in dictionary:

            dictionary[MSISDN] = {'ICCID':ICCID,'data':0.00000, 'sms':0.00000, 'other':0.00000, 'smscount':pricesms}
            print("Creating new dictionary: ", dictionary[MSISDN])

        else:
            print("Adding: ", price, " for: ", dictionary[MSISDN], "TYP: ",typ)
            add_dict(MSISDN, typ, price)
            if row['INCREMENT'] == "SMS":
                print("pricesms: ",pricesms," for unit: ",dictionary[MSISDN])
                add_dictsms(MSISDN, pricesms)





    #ptry:
        #print(dictionary[436761890319959]) #one with both types
    #pexcept:
        #pprint("Required unit is not in our set")
        #psys.exit(1)

#pprint(len(dictionary.keys()))

#for key, value in dictionary.items():
   #print(key, ' : ', value)


print("Count of units: ", len(dictionary.keys()))
#print("Count of sms: ",countofsms)
#for dict_value in dictionary:
#    type(dict_value)
#    #for k, v in dict_value.items():
     

#with open('fakturace_tmgdsp_export_20211110v2.csv', 'w') as f:
#   for key in dictionary.keys():
#      print(key,dictionary[key])
#      f.write("%s,%s\n"%(key,dictionary[key]))



csv_columns = ['takhleuztoneudelam', 'ICCID', 'data', 'sms', 'other', 'smscount']
try:
    with open('fakturace_tmgdsp_export_20211110v3.csv', 'w') as csvfile:
        w = csv.DictWriter(sys.stdout, csv_columns)
        for key, val in sorted(dictionary.items()):
            row = {'takhleuztoneudelam': key}
            row.update(val)

            writer = csv.DictWriter(csvfile, fieldnames=csv_columns)
            writer.writerow(row)

except IOError:
    print(f"I/O error: {IOError}")
